//
// Cursor Editor 0.01q for Linux    Qt Widgetekkel
//

// ******* Headerfileok ***********

#include <stdlib.h>
#include <fcntl.h>
#include <math.h>

#include <qbttngrp.h>
#include <qpushbt.h>
#include <qpopmenu.h>
#include <qdialog.h>
#include <qdir.h>
#include <qpainter.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qpixmap.h>
#include <qscrbar.h>
#include <qmsgbox.h>
#include <qfiledlg.h>
#include <qframe.h>
#include <qapp.h>
#include <qcolor.h>
#include <qevent.h>
#include <qlined.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qbitmap.h>

#include "toolbar/bmphandler.h"
#include "toolbar/toolbar.h"
#include "toolbar/standard.res"

#include "toolbar/leftbutt.res"
#include "bited.bit"
#include "rotate.res"
#include "l-r.h"

//***** Bitmap Resources **************

#include "toolbar/rock50.h"

//***** Constant definitions **********

#define WinX 460
#define WinY 380

#define NumX 32
#define NumY 32

#define pSiz 8

#define xMaxX 96
#define xMaxY 96

#define tableX 40
#define tableY 26

#define round(a) (int)floor(a+0.5)

#define rr2(a) (a       & 0x0000ff)
#define gg2(a) (a >> 8  & 0x0000ff)
#define bb2(a) (a >> 16 & 0x0000ff)

int defColors[16] =
{
  0x00000000,0x00000080,0x00008000,0x00008080,
  0x00800000,0x00800080,0x00808000,0x00808080,
  0x00c0c0c0,0x000000ff,0x0000ff00,0x0000ffff,
  0x00ff0000,0x00ff00ff,0x00ffff00,0x00ffffff,
};

int Colors[256];

//******* Globlis Tpusdeklarcik ********************

typedef struct TPoint
{
  int  x;
  int  y;
} TPoint;  

enum TDrwStyle
{ dwPoint  = 0x0, dwLine  = 0x1, dwSquare = 0x2,
  dwCircle = 0x3, dwFill  = 0x4, dwPaste  = 0x5 };

//****** Bitmaps *******************************

typedef struct tagBMPfhead
{
        unsigned short bfType __attribute__ ((packed));
        unsigned long  bfSize __attribute__ ((packed));
        unsigned short bfReserved1 __attribute__ ((packed));
        unsigned short bfReserved2 __attribute__ ((packed));
        unsigned long  bfOffBits __attribute__ ((packed));
} BMPfhead;

typedef struct tagBMPihead
{
        unsigned long  biSize;
        unsigned long  biWidth;
        unsigned long  biHeight;
        unsigned short biPlanes;
        unsigned short biBitCount;
        unsigned long  biCompression;
        unsigned long  biSizeImage;
        unsigned long  biXPelsPerMeter;
        unsigned long  biYPelsPerMeter; 
        unsigned long  biClrUsed;
        unsigned long  biClrImportant;
} BMPihead;

typedef struct TBitmapHeader
{
  BMPfhead fHead;
  BMPihead iHead;
} TBitmapHeader;

typedef union
{
  struct {
        unsigned short bfType __attribute__ ((packed));
        unsigned long  bfSize __attribute__ ((packed));
        unsigned short bfReserved1 __attribute__ ((packed));
        unsigned short bfReserved2 __attribute__ ((packed));
        unsigned long  bfOffBits __attribute__ ((packed));
        
        unsigned long  biSize  __attribute__ ((packed));
        unsigned long  biWidth  __attribute__ ((packed));
        unsigned long  biHeight  __attribute__ ((packed));
        unsigned short biPlanes  __attribute__ ((packed));
        unsigned short biBitCount  __attribute__ ((packed));
        unsigned long  biCompression  __attribute__ ((packed));
        unsigned long  biSizeImage  __attribute__ ((packed));
        unsigned long  biXPelsPerMeter  __attribute__ ((packed));
        unsigned long  biYPelsPerMeter  __attribute__ ((packed)); 
        unsigned long  biClrUsed  __attribute__ ((packed));
        unsigned long  biClrImportant  __attribute__ ((packed));
        
        int      color[256]  __attribute__ ((packed));
         } Header;
  char           bits[65536]  __attribute__ ((packed)); 
} TBitmap;

#define BMP_Compression 3

//****** Pascal szer String opertorok ********
//****** meg ami mg hinyzott a Pascalbl *****

int chpos(char a, char *s)
{
  int i;
  i=0;
  while( (s[i] != a) && (s[i] != '\0') ) { i++; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int nopos(char a, char *s)
{
  int i;
  i=0;
  while( (s[i] == a) && (s[i] != '\0') ) { i++; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

int rchpos(char a, char *s)
{
  int i;
  i=strlen(s);
  while( (s[i] != a) && (i>=0) ) { i--; }  
  if(i>strlen(s))
    return(0);
  else  
    return(i);
}

char *nevtoext(char *R, char *s, char *x)
{
  char T[256];
  int  i;
  strcpy(T,s);
  i=rchpos('.',s);
  if(i==0)
    {
      strcat(T,".");
      strcat(T,x);
    }  
  return strcpy(R,T);
}

int toInt(char *s)
{
  long i;
  unsigned short w;
  w = (sscanf(s, "%ld", &i) == 0);
  return(i);
}

int hxToDec(char *s)
{
  char Hx[17] = "0123456789abcdef";
  int i;
  i  = chpos(tolower(s[0]), Hx) * 16;
  i += chpos(tolower(s[1]), Hx);
  return i;
}

/* int hxToDec(char *s)
{
  int i;
  sscanf(s,"%x",&i);
  return i;
}*/

char *strsub(char *R, char *s, int f, int l)
{
  char T[256];
  int  i;
  for (i = 0; i < l; i++)
    T[i] = s[i + f];
  T[i] = '\0';
  return strcpy(R,T);
}

char *readln(FILE *f,char *R)
{
  char T[256];
  char *t;
  fgets(T, 256, f);
  t = strchr(T, '\n');
    if (t != NULL)
        *t = 0;
  return strcpy(R,T);
}

int rnd( int max )
{
  return( int( drand48()*max));
}

//******* 1 bit/pix. Pattern Operators ********************

int MaxX=xMaxX;
int MaxY=xMaxY;

//** Setting a 256 colored point

void plotPoint(uchar *xArr, int x, int y, uchar pst)
{
  if( (x>=0 && y>=0) && (x<MaxX && y<MaxY) )
    xArr[y*xMaxX+x]=pst;
}

uchar getPoint(uchar *xArr, int x, int y)
{
  if( (x>=0 && y>=0) && (x<MaxX && y<MaxY) )
    return(xArr[y*xMaxX+x]);
  else
    return(-1);  
}

void LineBetw(uchar *xArr, int x1, int y1, int x2, int y2, uchar pst)
{
  int x,y,z,a,b,dx,dy,d,deltap,deltaq;
  
  dx=abs(x2-x1);
  dy=abs(y2-y1);
  
  if(dy<=dx)
    {
      x=x1; y=y1; z=x2;
      if(x1<=x2)
        a=1;
      else
        a=-1;
          
      if(y1<=y2)
        b=1;
      else
        b=-1;  
      deltap=dy+dy;
      d=deltap-dx;
      deltaq=d-dx;
      plotPoint(xArr,x,y,pst);
      while(x!=z)
        {
          x=x+a;
          if(d<0)
            d=d+deltap;
          else
            {
              y=y+b;
              d=d+deltaq;
            }
          plotPoint(xArr,x,y,pst);
        }
    }
  else
    {
      x=x1; y=y1; z=y2;
      if(y1<=y2)
        a=1;
      else
        a=-1;
          
      if(x1<=x2)
        b=1;
      else
        b=-1;  
      deltap=dx+dx;
      d=deltap-dy;
      deltaq=d-dy;
      plotPoint(xArr,x,y,pst);
      while(y!=z)
        {
          y=y+a;
          if(d<0)
            d=d+deltap;
          else
            {
              x=x+b;
              d=d+deltaq;
            }
          plotPoint(xArr,x,y,pst);
        }
    }  
}

void DrawBox(uchar *xArr, int x1, int y1, int x2, int y2, uchar pst)
{
   LineBetw(xArr,x1,y1,x2,y1,pst);
   LineBetw(xArr,x2,y1,x2,y2,pst);
   LineBetw(xArr,x2,y2,x1,y2,pst);  
   LineBetw(xArr,x1,y2,x1,y1,pst);
}

double Deg2Rad(long ff)
{
  return (ff * M_PI / 180);
}

void DrawCirc(uchar *xArr, int xx1, int yy1, int xx2, int yy2, uchar pst)
{
  long r, f, dx, dy, px1, px2, py1, py2;

  dx = labs(xx1 - xx2);
  dy = labs(yy1 - yy2);
  r = (long)floor(sqrt((double)(dx * dx + dy * dy)) + 0.5);
  for (f = 1; f <= 180; f++) {
    px1 = (long)floor(r * cos(Deg2Rad(f * 2 - 2)) + 0.5);
    py1 = (long)floor(r * sin(Deg2Rad(f * 2 - 2)) + 0.5);
    px2 = (long)floor(r * cos(Deg2Rad(f * 2)) + 0.5);
    py2 = (long)floor(r * sin(Deg2Rad(f * 2)) + 0.5);
    LineBetw(xArr, xx1 + px1, yy1 + py1, xx1 + px2, yy1 + py2, pst);
  }
}


static uchar fcolor;
static int FillCnt=0;

void FloodFill(uchar *xArr, int xx, int yy, int colr)
{
  FillCnt++;
  if(FillCnt<32768 && xx>=0 && yy>=0 && xx<MaxX && yy<MaxY)
    if( getPoint(xArr,xx,yy) == fcolor )
      {
         plotPoint(xArr,xx,yy,colr);
         FloodFill(xArr,xx,yy-1,colr);
         FloodFill(xArr,xx,yy+1,colr);
         FloodFill(xArr,xx-1,yy,colr);
         FloodFill(xArr,xx+1,yy,colr);
      }
}


//******* Objektumdefincik *******************

#ifndef __INPUTBOX_H__
#define __INPUTBOX_H__
class InputBox : public QDialog
{
    Q_OBJECT;
public:
    QLineEdit* aLine;
    InputBox(QWidget* parent = NULL, const char* name = NULL);
};
#endif

#ifndef __XYINPUT_H__
#define __XYINPUT_H__
class XYInput : public QDialog
{
    Q_OBJECT;
public:
    QLineEdit* xLine;
    QLineEdit* yLine;
    XYInput(QWidget* parent = NULL, const char* name = NULL);
};
#endif

#ifndef __QRGBDLG__
#define __QRGBDLG__
class QRGBDlg : public QDialog 
{
    Q_OBJECT
public:
    int RGB, valR, valG, valB;
    
    QLabel     *rgbLabel,*ColorLabel;
    QScrollBar *RBar,*GBar,*BBar;

    QRGBDlg( QWidget *parent, const char *name );
public slots:
    void	RscrollChanged( int );
    void	GscrollChanged( int );
    void	BscrollChanged( int );
};
#endif


#ifndef __QHSVDLG__
#define __QHSVDLG__
class QHSVDlg : public QDialog 
{
    Q_OBJECT
public:
    int HSV, RGB, valH, valS, valV;
    
    QLabel     *rgbLabel,*ColorLabel;
    QScrollBar *HBar,*SBar,*VBar;

    QHSVDlg( QWidget *parent, const char *name );
public slots:
    void	HscrollChanged( int );
    void	SscrollChanged( int );
    void	VscrollChanged( int );
};
#endif

#ifndef __NLABEL__
#define __NLABEL__
class QNLabel : public QLabel
{
    Q_OBJECT
public:
    QNLabel( QWidget *parent=0, const char *name=0, WFlags f=0 );
    int idNum;
public slots:
    void         getNewBackColor( int cc );
    void         getNewBackInk( int cc );
protected:
    virtual void mousePressEvent( QMouseEvent *m );    
signals:
    void         Lclicked( int );
    void         Rclicked( int );
    void         RGBChanged( int , int);
};
#endif


#ifndef __CPICKER__
#define __CPICKER__
class QCPicker : public QFrame
{
    Q_OBJECT
public:
    int      *mxArr;
    int      boxSize;
    
    bool     pushed;

    QCPicker( NWidget *parent=0, int ww=1, int *xArr=NULL );

    void     reDraw();

public slots:
    void     getNewSize( int ww, int hh );
    void     getNewRGB( int id, int RGB );
    void     minus();
    void     plus();
    void     handleLclick(int val);
    void     handleRclick(int val);
       
signals:
    void     Lclicked( int );
    void     Rclicked( int );
    void     RGBChanged();

protected:
    void     paintEvent(  QPaintEvent  * );
    void     resizeEvent( QResizeEvent * );

private:
    QToolButton *lf, *rg;
    QNLabel     *qubes[128];
    int         W,P;
};
#endif

#ifndef __BITED_H__
#define __BITED_H__
class QBitmapEd : public QFrame
{
    Q_OBJECT
public:
    uchar    *mxArr;
    int      *palett;
    int      maxcolor;
    
    bool      pushed;
    uchar     lcolor,rcolor,color;
    
    TPoint    spot;
    TPoint    prevPos;
    TDrwStyle func;

    QBitmapEd( QWidget *parent=0, int ww=1, int hh=1, uchar *xArr=NULL, int *xPalett=NULL );

    void     setFunc(TDrwStyle v);

    void     reDraw();
    void     reSizeGrid(int x, int y);
    void     reSizeBox(int x, int y);
    
    void     reMoveBox(int x, int y);
    void     reMoveBoxX(int x);
    void     reMoveBoxY(int y);
    
protected:
    
    void     paintEvent( QPaintEvent * );
    void     mousePressEvent( QMouseEvent * );
    void     mouseMoveEvent( QMouseEvent * );
    void     mouseReleaseEvent( QMouseEvent * );

private:
    
    int      W,H;
    int      sizX,sizY;
    int      posX,posY;
    
    QBrush   b0( 0x0040c040 );  // Transparency
    QBrush   b1( 0x00ffffff );  // Mask & Body
    QBrush   b2( 0x00402020 );  // Mask
    QBrush   h0( 0x00f040f0 );  // HotSpot

signals:
    void     CursorMove( int , int );
    void     It_Done();
};
#endif // __BITED_H__

//********* Ablak Alapobjektum ***************

#ifndef __BITEDALAP_H__
#define __BITEDALAP_H__
class BmpEdMain : public NWidget
{
    Q_OBJECT
public:

    int        isPreload = FALSE;

    int        pNullX=10;
    int        pNullY=10;

    int        pattX=320;
    int        pattY=320;

    uchar      bits[xMaxX*xMaxY + 1];
    
    uchar      Ubits[xMaxX*xMaxY + 1];

    int        nColor;
    int        cLeft,cRight;

    int        UndoLevel;
    
    char       bitname[256];
    char       fname[256];
    
    int        xSiz,ySiz;

    BmpEdMain( QWidget *parent=0, const char *name=0 );

    void        init_data();

    void        savebpp(char *fnev);
    
    void        save4bpp(char *fnev);
    void        save8bpp(char *fnev);

    void        loadbits(char *fn);

    void        export4bpp(char *fnev);
    void        export8bpp(char *fnev);
    
public slots:
    void	q_new();
    void	q_open();
    void	q_save();
    void	q_saveas();
    void	q_import();
    void	q_export();
    void	q_quit();

    void        q_rename();
    void	q_bitstat4();
    void	q_bitstat8();
    void	q_clear();

    void	q_undo();
    void	done();
    
    void	q_redo();
    
    void	q_resize();
    
    void	q_about();
    
    void	q_test();

    void        q_rotUp();
    void        q_rotDown();
    void        q_rotLeft();
    void        q_rotRight();

    void        getLcolor(int v);
    void        getRcolor(int v);
    void        getRGBval();
    void        cursorMoved( int x, int y);
    void        Functions(int);
    
protected:
    void	resizeEvent( QResizeEvent * );
    
private:
    QToolBar    *Tool;

    int         LToolNum;
    QIDButton   *idb[5];
    
    QLabel      *lBox, *rBox, *testBox, *label;
    QCPicker    *cpick;
    
    QPopupMenu  *bitmap;
    int         bppstate,bpp4,bpp8;
    
    QMenuBar	*menu;
    QBitmapEd   *pbit;
    
    TPoint      Wpos,Wsiz;
};
#endif // __ALAP_H__

//**** Objektumok ************************************

// ************ PicEd Color Dialgus ****************

// ******* QRGBDlg *********

QRGBDlg:: QRGBDlg( QWidget *parent, const char *name )
          : QDialog( parent, name, TRUE )
{
   QString s;

   valR= parent->backgroundColor().red(); 
   valG= parent->backgroundColor().green(); 
   valB= parent->backgroundColor().blue(); 
   RGB=valR + (valG << 8) + (valB << 16);

   ColorLabel = new QLabel( this, "Label_Color" );
   ColorLabel->setGeometry( 10, 10, 140, 40 );
   ColorLabel->setFrameStyle( 50 );
   ColorLabel->setText( "" );
   ColorLabel->setBackgroundColor( RGB );

   RBar = new QScrollBar( this, "ScrollBar_R" );
   RBar->setGeometry( 10, 60, 140, 15 );
   RBar->setOrientation( QScrollBar::Horizontal );
   RBar->setRange( 0, 255 );
   RBar->setSteps( 1, 16 );
   RBar->setValue( valR );
   connect( RBar, SIGNAL(valueChanged(int)), SLOT(RscrollChanged(int)) );

   GBar = new QScrollBar( this, "ScrollBar_G" );
   GBar->setGeometry( 10, 80, 140, 15 );
   GBar->setOrientation( QScrollBar::Horizontal );
   GBar->setRange( 0, 255 );
   GBar->setSteps( 1, 16 );
   GBar->setValue( valG );
   connect( GBar, SIGNAL(valueChanged(int)), SLOT(GscrollChanged(int)) );

   BBar = new QScrollBar( this, "ScrollBar_B" );
   BBar->setGeometry( 10, 100, 140, 15 );
   BBar->setOrientation( QScrollBar::Horizontal );
   BBar->setRange( 0, 255 );
   BBar->setSteps( 1, 16 );
   BBar->setValue( valB );
   connect( BBar, SIGNAL(valueChanged(int)), SLOT(BscrollChanged(int)) );

   rgbLabel = new QLabel( this, "Label_RGB" );
   rgbLabel->setGeometry( 10, 120, 140, 20 );
   rgbLabel->setFrameStyle( 49 );
   s.sprintf("R:%i - G:%i - B:%i",valR,valG,valB);
   rgbLabel->setText( s );

   QPushButton *bok,*bcancel;
   bok = new QPushButton( this, "PushButton_Ok" );
   bok->setGeometry( 10, 150, 65, 20 );
   bok->setText( "Ok" );
   connect( bok, SIGNAL(clicked()), SLOT(accept()) );

   bcancel = new QPushButton( this, "PushButton_Canc" );
   bcancel->setGeometry( 85, 150, 65, 20 );
   bcancel->setText( "Cancel" );
   connect( bcancel, SIGNAL(clicked()), SLOT(reject()) );
   
   setGeometry(210,210,160,180);
}

void QRGBDlg::RscrollChanged( int value )
{
  QString s;
  valR=value;
  RGB=valR + (valG << 8) + (valB << 16);
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("R:%i - G:%i - B:%i",valR,valG,valB);
  rgbLabel->setText( s );
}
void QRGBDlg::GscrollChanged( int value )
{
  QString s;
  valG=value;
  RGB=valR + (valG << 8) + (valB << 16);
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("R:%i - G:%i - B:%i",valR,valG,valB);
  rgbLabel->setText( s );
}
void QRGBDlg::BscrollChanged( int value )
{
  QString s;
  valB=value;
  RGB=valR + (valG << 8) + (valB << 16);
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("R:%i - G:%i - B:%i",valR,valG,valB);
  rgbLabel->setText( s );
}

// ******* QHSVDlg *********

QHSVDlg::QHSVDlg( QWidget *parent, const char *name )
          : QDialog( parent, name, TRUE )
{
   QString s;

   parent->backgroundColor().hsv(&valH,&valS,&valV);
   
   RGB=parent->backgroundColor().rgb();

   ColorLabel = new QLabel( this, "Label_Color" );
   ColorLabel->setGeometry( 10, 10, 140, 40 );
   ColorLabel->setFrameStyle( 50 );
   ColorLabel->setText( "" );
   ColorLabel->setBackgroundColor( RGB );

   HBar = new QScrollBar( this, "ScrollBar_H" );
   HBar->setGeometry( 10, 60, 140, 15 );
   HBar->setOrientation( QScrollBar::Horizontal );
   HBar->setRange( 0, 359 );
   HBar->setSteps( 1, 15 );
   HBar->setValue( valH );
   connect( HBar, SIGNAL(valueChanged(int)), SLOT(HscrollChanged(int)) );

   SBar = new QScrollBar( this, "ScrollBar_S" );
   SBar->setGeometry( 10, 80, 140, 15 );
   SBar->setOrientation( QScrollBar::Horizontal );
   SBar->setRange( 0, 255 );
   SBar->setSteps( 1, 16 );
   SBar->setValue( valS );
   connect( SBar, SIGNAL(valueChanged(int)), SLOT(SscrollChanged(int)) );

   VBar = new QScrollBar( this, "ScrollBar_V" );
   VBar->setGeometry( 10, 100, 140, 15 );
   VBar->setOrientation( QScrollBar::Horizontal );
   VBar->setRange( 0, 255 );
   VBar->setSteps( 1, 16 );
   VBar->setValue( valV );
   connect( VBar, SIGNAL(valueChanged(int)), SLOT(VscrollChanged(int)) );

   rgbLabel = new QLabel( this, "Label_RGB" );
   rgbLabel->setGeometry( 10, 120, 140, 20 );
   rgbLabel->setFrameStyle( 49 );
   s.sprintf("H:%i - S:%i - V:%i",valH,valS,valV);
   rgbLabel->setText( s );

   QPushButton *bok,*bcancel;
   bok = new QPushButton( this, "PushButton_Ok" );
   bok->setGeometry( 10, 150, 65, 20 );
   bok->setText( "Ok" );
   connect( bok, SIGNAL(clicked()), SLOT(accept()) );

   bcancel = new QPushButton( this, "PushButton_Canc" );
   bcancel->setGeometry( 85, 150, 65, 20 );
   bcancel->setText( "Cancel" );
   connect( bcancel, SIGNAL(clicked()), SLOT(reject()) );
   
   setGeometry(190,190,160,180);
}

void QHSVDlg::HscrollChanged( int value )
{
  QColor col;
  
  QString s;

  valH=value;
  col.setHsv(valH,valS,valV);
  RGB=col.rgb();
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("H:%i - S:%i - V:%i",valH,valS,valV);
  rgbLabel->setText( s );
}
void QHSVDlg::SscrollChanged( int value )
{
  QColor col;
  
  QString s;

  valS=value;
  col.setHsv(valH,valS,valV);
  RGB=col.rgb();
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("H:%i - S:%i - V:%i",valH,valS,valV);
  rgbLabel->setText( s );
}
void QHSVDlg::VscrollChanged( int value )
{
  QColor col;
  
  QString s;

  valV=value;
  col.setHsv(valH,valS,valV);
  RGB=col.rgb();
  ColorLabel->setBackgroundColor( RGB );
  s.sprintf("H:%i - S:%i - V:%i",valH,valS,valV);
  rgbLabel->setText( s );
}


// ******* QNLabel *********

QNLabel::QNLabel( QWidget *parent, const char *name, WFlags f )
        :QLabel(parent,name,f)
{
   setBackgroundColor(white);
}

void QNLabel::getNewBackColor( int cc )
{
   setBackgroundColor( cc );   
}

void QNLabel::getNewBackInk( int cc )
{
   setBackgroundColor( Colors[cc] );   
}

void QNLabel::mousePressEvent( QMouseEvent *m )
{
   if( m->button() == LeftButton )
     {
        if((m->state() & AltButton) != 0)
          {
             QRGBDlg d(this,"RGB Color Mixing");
             if(d.exec())
               {
                 setBackgroundColor(d.RGB);
                 emit RGBChanged(idNum, d.RGB);
               }
           }
         else if((m->state() & ControlButton) != 0)
           {
             QHSVDlg d(this,"HSV Color Mixing");
             if(d.exec())
               {
                 setBackgroundColor(d.RGB);
                 emit RGBChanged(idNum, d.RGB);
               }
           }
        else
          emit Lclicked( idNum );
     }
   else if( m->button() == RightButton )
     emit Rclicked( idNum );
}

//**** QCPicker **********************************

QCPicker::QCPicker( NWidget *parent, int ww, int *xArr )
    : QFrame( parent )
{
  mxArr=xArr;

  int i;
  
  W=ww; P=0;
  
  boxSize=20;

  setBackgroundColor(0x00808080);   
   
  for(i=0;i<=127;i++)
    {
      qubes[i]= new QNLabel(this);
      qubes[i]->idNum = i;
      qubes[i]->setFrameStyle( Panel | Sunken );
      qubes[i]->resize(boxSize,boxSize);
      qubes[i]->move(i*boxSize+boxSize+3,3);
      qubes[i]->setBackgroundColor(mxArr[i]); 
      connect(qubes[i],SIGNAL(RGBChanged(int,int)),SLOT(getNewRGB(int,int)));
      connect(qubes[i],SIGNAL(Lclicked(int)),SLOT(handleLclick(int)));
      connect(qubes[i],SIGNAL(Rclicked(int)),SLOT(handleRclick(int)));
    }
  lf = new QToolButton(this, bm_left);
  rg = new QToolButton(this, bm_right);    

  connect(lf,SIGNAL(clicked()),SLOT(minus()));
  connect(rg,SIGNAL(clicked()),SLOT(plus()));
 
  connect(parent,SIGNAL(sizeChanged(int,int)),SLOT(getNewSize(int,int)));
}

void QCPicker::reDraw()
{
  int i,n;
  for(i=0;i<=127;i++)
    {
      if((i+3)*boxSize+6>=width())
        qubes[i]->hide();     
      else
        {
          qubes[i]->resize(boxSize,boxSize);
          qubes[i]->move(i*boxSize+boxSize+3,3);
          qubes[i]->show();     
          qubes[i]->setBackgroundColor(mxArr[i+P]); 
        }
    }   
  lf->move(3,3);
  rg->move(width()-boxSize-3,3);  
}

void QCPicker::minus()
{
  int n;
  P=P-5;
  if(P<0) P=0;
  reDraw();
}

void QCPicker::plus()
{
  int n;
  n=(width()-3*boxSize-6)/boxSize;
  P=P+5;
  if(P>W-n) P=W-n;
  reDraw();
}

void QCPicker::handleLclick(int val)
{
  emit Lclicked(val + P);
}

void QCPicker::handleRclick(int val)
{
  emit Rclicked(val + P);
}

void QCPicker::getNewSize( int ww, int hh )
{
  reDraw();
}

void QCPicker::getNewRGB( int id, int RGB )
{
  mxArr[id+P]=RGB;
  emit RGBChanged();
}
   
void QCPicker::paintEvent( QPaintEvent * )
{
   reDraw();
}

void QCPicker::resizeEvent( QResizeEvent * )
{
   reDraw();
}

//**** InputBox   ************************************

InputBox::InputBox(QWidget* parent, const char* name)
         :QDialog( parent, name, TRUE )
{
	aLine = new QLineEdit( this );
	aLine->setGeometry( 10, 10, 165, 25 );
	aLine->setText( "" );
        connect( aLine, SIGNAL(returnPressed()), SLOT(accept()) );

	QPushButton *OkButton,*CancButton;
	OkButton = new QPushButton( this );
	OkButton->setGeometry( 10, 40, 70, 25 );
	OkButton->setText( "O&k" );
        connect( OkButton, SIGNAL(clicked()), SLOT(accept()) );

	CancButton = new QPushButton( this );
	CancButton->setGeometry( 85, 40, 90, 25 );
	CancButton->setText( "&Cancel" );
        connect( CancButton, SIGNAL(clicked()), SLOT(reject()) );

	parent->resize( 185, 75 );
        aLine->setFocus();
}

//**** XYInput Box ************************************

XYInput::XYInput(QWidget* parent = NULL, const char* name = NULL)
        :QDialog( parent, name, TRUE )
{
	QLabel* tmpQLabel;
	tmpQLabel = new QLabel( this, "Label_1" );
	tmpQLabel->setGeometry( 10, 15, 25, 25 );
	tmpQLabel->setText( "X:" );
	tmpQLabel = new QLabel( this, "Label_2" );
	tmpQLabel->setGeometry( 10, 50, 25, 25 );
	tmpQLabel->setText( "Y:" );

	xLine = new QLineEdit( this, "XLine" );
	xLine->setGeometry( 40, 15, 125, 25 );
	xLine->setText( "" );
        connect( xLine, SIGNAL(returnPressed()), SLOT(accept()) );

	yLine = new QLineEdit( this, "YLine" );
	yLine->setGeometry( 40, 50, 125, 25 );
	yLine->setText( "" );
        connect( yLine, SIGNAL(returnPressed()), SLOT(accept()) );

	QPushButton *OkButton,*CancButton;
	OkButton = new QPushButton( this, "OkButton" );
	OkButton->setGeometry( 10, 85, 65, 25 );
	OkButton->setText( "&OK" );
        connect( OkButton, SIGNAL(clicked()), SLOT(accept()) );

	CancButton = new QPushButton( this, "CancelButton" );
	CancButton->setGeometry( 80, 85, 85, 25 );
	CancButton->setText( "&Cancel" );
        connect( CancButton, SIGNAL(clicked()), SLOT(reject()) );

	parent->resize( 175, 120 );
        xLine->setFocus();
}

//**** QBitmapEd   ************************************

QBitmapEd::QBitmapEd( QWidget *parent=0, int ww=1, int hh=1, uchar *xArr=NULL, int *xPalett=NULL )
    : QFrame( parent )
{
  mxArr=xArr;
  palett=xPalett;

  W=ww;    H=hh;
  MaxX=ww; MaxY=hh;
  
  sizX=7; sizY=7;
  posX=0; posY=0;
  
  lcolor=0; rcolor=0; color=1; fcolor=0;
  
  prevPos.x=-1;   prevPos.y=-1;
  spot.x=-1; spot.y=-1;
  
  func=dwPoint;
  
  resize(W*sizX+1,H*sizY+1);
  move(1,1);  
  setFrameStyle( Box | Plain );
  setLineWidth( 1 );
  setMouseTracking(TRUE);
}

void QBitmapEd::setFunc(TDrwStyle v)
{
   func=v;
}

void QBitmapEd::reSizeGrid(int x, int y)
{
  sizX=x; sizY=y;
  resize(W*sizX+1,H*sizY+1);
}

void QBitmapEd::reSizeBox(int x, int y)
{
  W=x; H=y;
  MaxX=x; MaxY=y;
  resize(W*sizX+1,H*sizY+1);  
}

void QBitmapEd::reMoveBox(int x, int y)
{
  posX=x; posY=y;
  if(posX>xMaxX-W)
    posX=xMaxX-W;
  if(posY>xMaxY-H)
    posY=xMaxY-H;
  reDraw();
}

void QBitmapEd::reMoveBoxX(int x)
{
  posX=x;
  if(posX>xMaxX-W)
    posX=xMaxX-W;
  reDraw();
}

void QBitmapEd::reMoveBoxY(int y)
{
  posY=y;
  if(posY>xMaxY-H)
    posY=xMaxY-H;
  reDraw();
}

void QBitmapEd::reDraw()
{
  int i,j;
  QPainter p;
  QBrush b(0xffffff);
 
  p.begin( this );
  for( j = 0; j <= H-1; j++ )
    {
      for ( i = 0; i <= W-1; i++ )
        {
          b.setColor(palett[getPoint(mxArr,posX+i,posY+j)]);
//        b.setColor(0x00f0ffff);
          p.setBrush(b);
          p.drawRect(i*sizX,j*sizY,sizX+1,sizY+1);
        }
    }
  p.end();
}

void QBitmapEd::paintEvent( QPaintEvent *e )
{
  reDraw();
}

void QBitmapEd::mousePressEvent( QMouseEvent *e )
{
  int i,j,x,y;
  QString z;
  if(e->button()==LeftButton || e->button()==RightButton)
    {
      emit It_Done();
      x=e->x()/sizX;
      y=e->y()/sizY;
      
      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  
      
      if(e->button()==LeftButton)
        color=lcolor;
      else if(e->button()==RightButton)
        color=rcolor;
      
      if(e->state() == ControlButton)
        {  
           spot.x=x+posX;
           spot.y=y+posY;
           reDraw();
        }
      else  
        switch( func )
          {
            case dwFill:
              FillCnt=0;
              fcolor=getPoint(mxArr,posX+x,posY+y);
              FloodFill(mxArr,posX+x,posY+y,color);
              reDraw();     
            break; 
            case dwPoint:
            case dwLine:
            case dwSquare:
            case dwCircle:
              pushed=TRUE;
            break;  
            default: {}
          }  
      prevPos.x=x+posX;
      prevPos.y=y+posY;
    }  
}

void QBitmapEd::mouseMoveEvent( QMouseEvent *e )
{
  int i,j,x,y;
  x=e->x()/sizX;
  y=e->y()/sizY;
  
  if( (prevPos.x != x+posX) && (prevPos.y != y+posY))
    emit CursorMove(x,y);
  
  if(pushed && (e->state()==LeftButton || e->state()==RightButton))
    {
      if(e->state()==LeftButton)
        color=lcolor;
      else if(e->state()==RightButton)
        color=rcolor;

      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  

      if(func == dwPoint)
        {      
          prevPos.x=x+posX;
          prevPos.y=y+posY;
          plotPoint(mxArr,posX+x,posY+y,color);
          reDraw();  
       }
    } 
}

void QBitmapEd::mouseReleaseEvent( QMouseEvent *e )
{
  int i,j,x,y;
  QString z;
  if( pushed )
    {
      pushed=FALSE;
      
      if(e->state()==LeftButton)
        color=lcolor;
      else if(e->state()==RightButton)
        color=rcolor;
      
      x=e->x()/sizX;
      y=e->y()/sizY;

      if(y<0) y=0;
      if(y>xMaxY) y=xMaxY;  
  
      if(x<0) x=0;
      if(x>xMaxX) x=xMaxX;  
      
      if(x+posX == prevPos.x && y+posY == prevPos.y)
         plotPoint(mxArr,posX+x,posY+y,color);
      else
        switch( func )
          {
             case dwPoint:      
               plotPoint(mxArr,posX+x,posY+y,color);
             break;
             case dwLine:      
               LineBetw(mxArr,prevPos.x,prevPos.y,x+posX,y+posY,color);
             break;
             case dwSquare:      
               DrawBox(mxArr,prevPos.x,prevPos.y,x+posX,y+posY,color);
             break;  
             case dwCircle:      
               DrawCirc(mxArr,prevPos.x,prevPos.y,x+posX,y+posY,color);
             break;
          }
       reDraw();   
    }
}

//**** BmpEdMain   ************************************

BmpEdMain::BmpEdMain( QWidget *parent, const char *name )
    : NWidget( parent, name )
{
    int i,j,k;

    TGombRekord Gombok[] =
    { {T1016,SLOT(  q_quit()) ,6 ,"Exit"},

      {T1001,SLOT(  q_new())  ,0 ,"File New"},
      {T1002,SLOT(  q_open()) ,0 ,"File Open"},
      {T1003,SLOT(  q_save()) ,6 ,"File Save"},
      
      {T1009,SLOT(  q_undo()) ,0 ,"Edit Undo"},
      {T1010,SLOT(  q_clear()),6 ,"Edit Clear"},
      
      {bmRotUp  , SLOT( q_rotUp())   ,0 ,"Rotate Up"},
      {bmRotDown, SLOT( q_rotDown()) ,0 ,"Rotate Down"},
      {bmRotLeft, SLOT( q_rotLeft()) ,0 ,"Rotate Left"},
      {bmRotRight,SLOT( q_rotRight()),6 ,"Rotate Right"},

      {T1013,SLOT(  q_about()),0 ,"Help About"} };
    
//***** Alap menstruktra

    QPopupMenu *file = new QPopupMenu;
    CHECK_PTR( file );
    file->insertItem( "&New",        this, SLOT(q_new()) );
    file->insertItem( "&Open...",    this, SLOT(q_open()) );
    file->insertItem( "&Save",       this, SLOT(q_save()) );
    file->insertItem( "Save &As...", this, SLOT(q_saveas()) );
    file->insertSeparator();    
    file->insertItem( "&Import...",  this, SLOT(q_import()) );
    file->insertItem( "&Export...",  this, SLOT(q_export()) );
    file->insertSeparator();    
    file->insertItem( "E&xit",       this, SLOT(q_quit()) );

    QPopupMenu *edit = new QPopupMenu;
    CHECK_PTR( edit );
    edit->insertItem( "&Undo", this, SLOT(q_undo()) );
    
    bitmap = new QPopupMenu;
    CHECK_PTR( bitmap );
    bitmap->insertItem( "&Resize...", this, SLOT(q_resize()) );
    bitmap->insertItem( "Re&name...", this, SLOT(q_rename()) );
    bitmap->insertSeparator();    
    bpp4=bitmap->insertItem( " 16 &colour", this, SLOT(q_bitstat4()) );
    bpp8=bitmap->insertItem( "256 c&olour", this, SLOT(q_bitstat8()) );
    bitmap->insertSeparator();    
    bitmap->insertItem( "&Clear", this, SLOT(q_clear()) );
    bitmap->setCheckable( TRUE );    
    bitmap->setItemChecked( bpp4, TRUE );
    bitmap->setItemChecked( bpp8, FALSE );
    bppstate=0;
    
    QPopupMenu *help = new QPopupMenu;
    CHECK_PTR( help );
    help->insertItem( "&About...", this, SLOT(q_about()) );

    menu = new QMenuBar( this );
    CHECK_PTR( menu );
    menu->insertItem( "&File",  file );
    menu->insertItem( "&Edit",  edit );
    menu->insertItem( "&Bitmap",bitmap);
    menu->insertItem( "&Help",  help );

  
    Tool = new QToolBar(this, 11, Gombok);
    Tool->setBaseYPoint(menu->height());
    
//***** Vltozk s adatterletek

    TGomb1Rekord Muvelet[]=
    { {PPOINT ,GPOINT ,"\0",0},
      {PLINE  ,GLINE  ,"\0",0},
      {PSQUAR ,GSQUAR ,"\0",0},
      {PCIRCL ,GCIRCL ,"\0",0},
      {PFILL  ,GFILL  ,"\0",0}
    };

    init_data();
//***** Widgetek 

    label = new QLabel( this );
    label -> setFrameStyle(QFrame::Box | QFrame::Sunken);
    label -> setLineWidth(1);
    
    cpick = new QCPicker( this, 256, Colors );

    LToolNum=0;

    for(i=0;i<=4;i++)
      {
        idb[i] = new QIDButton(this, i, Muvelet[i].Bit1Tomb,
        Muvelet[i].Bit2Tomb);
        idb[i]->move(0,menu->height()+26+i*32);
        connect(idb[i], SIGNAL(clicked( int )), SLOT( Functions(int) ));
      }
    idb[LToolNum]->setState(1);  

    pbit = new QBitmapEd( this, 32, 32, bits, Colors );
    pbit->reSizeGrid(7,7);

    connect(pbit,SIGNAL(CursorMove(int,int)),SLOT(cursorMoved(int,int)));
//    connect(pbit,SIGNAL(It_Done()),SLOT(done()));
    
    lBox = new QLabel(this);
    rBox = new QLabel(this);

    lBox->setFrameStyle( 0x000022 );
    lBox->setLineWidth( 1 );
    lBox->setBackgroundColor( Colors[0] );
    lBox->setGeometry( 0,214,16,32);
       
    rBox->setFrameStyle( 0x000022 );
    rBox->setLineWidth( 1 );
    rBox->setBackgroundColor( Colors[8] );
    rBox->setGeometry(16,214,16,32);
    
    QPushButton *pb = new QPushButton(this);
    pb->setText("Test");
    pb->setGeometry(0,246,32,24);
    connect(pb,SIGNAL(clicked()),SLOT(q_test()));
    
    testBox = new QLabel( this );
    testBox -> setLineWidth(1);
    testBox -> setFrameStyle(QFrame::Box | QFrame::Raised);
    testBox -> resize(xSiz+12,ySiz+12);
    testBox -> setBackgroundColor(0x00d0d0d0);
    
    pbit->lcolor=0;
    pbit->rcolor=8;
    
    connect(cpick,SIGNAL(Lclicked( int )),SLOT(getLcolor( int )));
    connect(cpick,SIGNAL(Rclicked( int )),SLOT(getRcolor( int )));
    connect(cpick,SIGNAL(RGBChanged()),SLOT(getRGBval()));

//***** Ablak belltsok

    setMinimumSize( WinX, WinY );
    setCaption("BitEd - []");
//    done();
    QPixmap icon;
    icon.loadFromData((unsigned char *) &icBitEd,bitmapSize(icBitEd));
    icon.setMask( icon.createHeuristicMask() );
    setIcon(icon);
    setIconText("BitmapEd");
}

void BmpEdMain::init_data()
{
  int i;

  for(i=0; i<=xMaxX*xMaxY; i++)
    bits[i]=15;
  for(i=0;i<16;i++)  
    Colors[i]=defColors[i];
  for(i=16;i<256;i++)
    Colors[i]=0x00ffffff;
  strcpy(bitname,"");
  strcpy(fname,"");
  xSiz=32; ySiz=32;
  UndoLevel=0;
}

// ******* F objektumok ***********

void BmpEdMain::q_quit()
{
  if(isPreload && QMessageBox::query("Question","Do you want to save file?"))
    q_save();
  qApp->quit();    
}

void BmpEdMain::q_open()
{
  char r[257];

  QString s( QFileDialog::getOpenFileName(".","*.bit") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      loadbits(r);
      testBox -> resize(xSiz+12,ySiz+12);
      testBox -> move( 0, height()-testBox->height()-20);
      q_test();
    } 
}

void BmpEdMain::loadbits(char *fn)
{
  char c,d,e;
  int i,j,k,l,lx,idx,cr,cg,cb;
  char r[257],cs[257];
  char *T;
  TBitmap bit;
  QString s;
  
  char s1[256], s2[256], s3[256], s4[256];
  char line[1024], hln[256], hb[256];
  unsigned short w;
  QString z;
  FILE *be;

  strcpy(r,fn);
  q_new();
  nevtoext(r,r,"bit");
  
  strcpy(fname,r);
  be=fopen(r,"r");
  readln(be,s1);
  strsub(bitname,s1,10,strlen(s1));
  readln(be,line);
  readln(be,line);
  
  s.sprintf("BitEd - [%s]",bitname);
  setCaption(s);
  
  strcpy(line, " ");
  i = 0;
  while ( *line != '\0' ) 
    {
      readln(be,line);
      strcpy(hln,line);
      while ( *hln != '\0' ) 
        {
          strsub(hb,  hln, 2, 2);
          strsub(hln,hln, 5, strlen(hln)-5);
          bit.bits[i] = hxToDec(hb);
          i++;
        }
    }
  xSiz=bit.Header.biWidth;
  ySiz=bit.Header.biHeight;
  pbit->reSizeBox(xSiz,ySiz);
      
  k=bit.Header.bfOffBits;
    
  if(bit.Header.biBitCount==8)
    {
      lx=(xSiz+3)/4*4;
      for(j=0;j<=ySiz;j++)
        {
          for(i=0;i<=xSiz;i++)
            plotPoint(pbit->mxArr,i,(ySiz-1)-j,bit.bits[k+i]);
          k+=lx;  
        }
    }
  else if(bit.Header.biBitCount==4)
    {
      lx=(xSiz+7)/8*4;
      for(j=0;j<=ySiz;j++)
        {
          for(i=0;i<=xSiz/2;i++)
            {
               e=bit.bits[k+i];
               c=     e & 0x0f;
               d=e >> 4 & 0x0f;
               plotPoint(pbit->mxArr,i*2+0,(ySiz-1)-j,d);
               plotPoint(pbit->mxArr,i*2+1,(ySiz-1)-j,c);
            }
          k+=lx;  
        }
    } 
  for(i=0;i<bit.Header.biClrUsed;i++)
    {
      cr=rr2(bit.Header.color[i]);
      cg=gg2(bit.Header.color[i]);
      cb=bb2(bit.Header.color[i]);
      Colors[i]= cr << 16 | cg << 8 | cb;
    }
  fclose(be);
}

void BmpEdMain::q_save()
{
   if( strlen(fname)!=0)
     savebpp(fname);
   else
     q_saveas();  
}

void BmpEdMain::q_saveas()
{
  char r[257],cs[257];
  
  if( strlen(bitname) == 0)
    q_rename();
  
  QString s( QFileDialog::getSaveFileName(".","*.bit") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      strcpy(fname,s);
      nevtoext(r,r,"bit");
      savebpp(r);
    }
}

void BmpEdMain::savebpp(char *fnev)
{
  if(bppstate==0)
    save4bpp(fnev);
  else  
    save8bpp(fnev);
}

void BmpEdMain::save4bpp(char *fnev)
{
  char c,d;
  int i,j,k,ll,lx,cr,cg,cb;
  FILE *ki;
  TBitmap bit;
  ki=fopen(fnev,"w");
  
  lx=(xSiz+7)/8*4;  
      
  for(i=0;i<=65535;i++)
    bit.bits[i]=0;
  bit.Header.bfType=0x4d42;
  bit.Header.bfSize=sizeof(TBitmapHeader)+4*16+lx*ySiz;
  bit.Header.bfOffBits=sizeof(TBitmapHeader)+4*16;
  bit.Header.biSize=sizeof(BMPihead);
  bit.Header.biWidth=xSiz;
  bit.Header.biHeight=ySiz;
  bit.Header.biPlanes=1;
  bit.Header.biBitCount=4;
  bit.Header.biSizeImage=lx*ySiz;
  bit.Header.biClrUsed=16;
  bit.Header.biClrImportant=0;
  for(i=0;i<=16;i++)
    {
      cr=rr2(Colors[i]);
      cg=gg2(Colors[i]);
      cb=bb2(Colors[i]);
      bit.Header.color[i]= cr << 16 | cg << 8 | cb;
    } 
  k=0;
  for(j=0;j<=ySiz;j++)
    {
      for(i=0;i<=xSiz/2;i++)
        {
           c=getPoint(bits,2*i+0,(ySiz-1)-j) << 4;
           d=getPoint(bits,2*i+1,(ySiz-1)-j) &  0x0f;
           bit.bits[bit.Header.bfOffBits+k+i]=c | d;
        }   
        k+=lx;
    } 
  
  fprintf(ki,"// BITMAP %s\n",bitname);
  fprintf(ki,"uchar %s[]=\n{\n",bitname);
  ll=bit.Header.bfSize/16;
  k=0;
  for(j=0; j<ll; j++)
    {
      for(i=0; i<16; i++)
        {
          fprintf(ki,"0x%.2x,",(uchar) bit.bits[k]);
          k++;
        }
      fprintf(ki,"\n",NULL);
    }     
  for(i=0; i< bit.Header.bfSize-ll*16; i++)
    {
       fprintf(ki,"0x%.2x,",(uchar) bit.bits[k]);
       k++;
    }   
  if(ll!=0)  
  fprintf(ki,"\n",NULL);
  fprintf(ki,"};\n\n\n",NULL);
  fclose(ki);    
}

void BmpEdMain::save8bpp(char *fnev)
{
  char c,d;
  int i,j,k,ll,lx,cr,cg,cb;
  FILE *ki;
  TBitmap bit;
  ki=fopen(fnev,"w");

  lx=(xSiz+3)/4*4;
      
  for(i=0;i<=65535;i++)
    bit.bits[i]=0;
  bit.Header.bfType=0x4d42;
  bit.Header.bfSize=sizeof(TBitmapHeader)+4*256+lx*ySiz;
  bit.Header.bfOffBits=sizeof(TBitmapHeader)+4*256;
  bit.Header.biSize=sizeof(BMPihead);
  bit.Header.biWidth=xSiz;
  bit.Header.biHeight=ySiz;
  bit.Header.biPlanes=1;
  bit.Header.biBitCount=8;
  bit.Header.biSizeImage=lx*ySiz;
  bit.Header.biClrUsed=256;
  bit.Header.biClrImportant=0;
  for(i=0;i<=255;i++)
    {
      cr=rr2(Colors[i]);
      cg=gg2(Colors[i]);
      cb=bb2(Colors[i]);
      bit.Header.color[i]= cr << 16 | cg << 8 | cb;
    } 
  k=0;
  for(j=0;j<=ySiz;j++)
    {
      for(i=0;i<=xSiz;i++)
        bit.bits[bit.Header.bfOffBits+k+i]=getPoint(bits,i,(ySiz-1)-j);
      k+=lx;  
    } 
      
  fprintf(ki,"// BITMAP %s\n",bitname);
  fprintf(ki,"uchar %s[]=\n{\n",bitname);
  ll=bit.Header.bfSize/16;
  k=0;
  for(j=0; j<ll; j++)
    {
      for(i=0; i<16; i++)
        {
          fprintf(ki,"0x%.2x,",(uchar) bit.bits[k]);
          k++;
        }
      fprintf(ki,"\n",NULL);
    }     
  for(i=0; i< bit.Header.bfSize-ll*16; i++)
    {
       fprintf(ki,"0x%.2x,",(uchar) bit.bits[k]);
       k++;
    }   
  if(ll!=0)  
  fprintf(ki,"\n",NULL);
  fprintf(ki,"};\n\n\n",NULL);
  fclose(ki);    
}

void BmpEdMain::q_import()
{
  char c,d,e;
  int i,j,k,l,lx,idx,cr,cg,cb;
  char r[257],cs[257];
  TBitmap bit;
  
  char s1[256], s2[256], s3[256], s4[256];
  char line[1024], hln[256], hb[256];
  unsigned short w;
  QString z;
  FILE *be;

  QString s( QFileDialog::getOpenFileName(".","*.bmp") );
  if ( ! s.isNull() )
    {
      q_new();
      strcpy(r,s);
      nevtoext(r,r,"bmp");
      strcpy(fname,r);
      be=fopen(r,"r");
      
      i=fread(bit.bits,1,65536,be);
     
      xSiz=bit.Header.biWidth;
      ySiz=bit.Header.biHeight;
      pbit->reSizeBox(xSiz,ySiz);
      
      k=bit.Header.bfOffBits;
      
      if(bit.Header.biBitCount==8)
        {
          lx=(xSiz+3)/4*4;
          for(j=0;j<=ySiz;j++)
            {
              for(i=0;i<=xSiz;i++)
                plotPoint(pbit->mxArr,i,(ySiz-1)-j,bit.bits[k+i]);
              k+=lx;  
            }
          }
      else if(bit.Header.biBitCount==4)
        {
          lx=(xSiz+7)/8*4;
          for(j=0;j<=ySiz;j++)
            {
              for(i=0;i<=xSiz/2;i++)
                {
                   e=bit.bits[k+i];
                   c=     e & 0x0f;
                   d=e >> 4 & 0x0f;
                   plotPoint(pbit->mxArr,i*2+0,(ySiz-1)-j,d);
                   plotPoint(pbit->mxArr,i*2+1,(ySiz-1)-j,c);
                }
              k+=lx;  
            }
        } 
      for(i=0;i<bit.Header.biClrUsed;i++)
        {
          cr=rr2(bit.Header.color[i]);
          cg=gg2(bit.Header.color[i]);
          cb=bb2(bit.Header.color[i]);
          Colors[i]= cr << 16 | cg << 8 | cb;
        }
     
      fclose(be);
      testBox -> resize(xSiz+12,ySiz+12);
      testBox -> move( 0, height()-testBox->height()-20);
      q_test();
    } 
}

void BmpEdMain::q_export()
{
  char r[257],cs[257];
  QString s( QFileDialog::getSaveFileName(".","*.bmp") );
  if ( ! s.isNull() )
    {
      strcpy(r,s);
      nevtoext(r,r,"bmp");
      if(bppstate==0)
        export4bpp(r);
      else  
        export8bpp(r);
    }
}

void BmpEdMain::export4bpp(char *fnev)
{
  char c,d;
  int i,j,k,lx,cr,cg,cb;
  FILE *ki;
  TBitmap bit;
  ki=fopen(fnev,"w");
  
  lx=(xSiz+7)/8*4;  
      
  for(i=0;i<=65535;i++)
    bit.bits[i]=0;
  bit.Header.bfType=0x4d42;
  bit.Header.bfSize=sizeof(TBitmapHeader)+4*16+lx*ySiz;
  bit.Header.bfOffBits=sizeof(TBitmapHeader)+4*16;
  bit.Header.biSize=sizeof(BMPihead);
  bit.Header.biWidth=xSiz;
  bit.Header.biHeight=ySiz;
  bit.Header.biPlanes=1;
  bit.Header.biBitCount=4;
  bit.Header.biSizeImage=lx*ySiz;
  bit.Header.biClrUsed=16;
  bit.Header.biClrImportant=0;
  for(i=0;i<=16;i++)
    {
      cr=rr2(Colors[i]);
      cg=gg2(Colors[i]);
      cb=bb2(Colors[i]);
      bit.Header.color[i]= cr << 16 | cg << 8 | cb;
    } 
  k=0;
  for(j=0;j<=ySiz;j++)
    {
      for(i=0;i<=xSiz/2;i++)
        {
           c=getPoint(bits,2*i+0,(ySiz-1)-j) << 4;
           d=getPoint(bits,2*i+1,(ySiz-1)-j) &  0x0f;
           bit.bits[bit.Header.bfOffBits+k+i]=c | d;
        }   
        k+=lx;
    } 
      
  fwrite(bit.bits, 1, bit.Header.bfSize,ki);
  fclose(ki);    
}

void BmpEdMain::export8bpp(char *fnev)
{
  char c,d;
  int i,j,k,lx,cr,cg,cb;
  FILE *ki;
  TBitmap bit;
  ki=fopen(fnev,"w");

  lx=(xSiz+3)/4*4;
      
  for(i=0;i<=65535;i++)
    bit.bits[i]=0;
  bit.Header.bfType=0x4d42;
  bit.Header.bfSize=sizeof(TBitmapHeader)+4*256+lx*ySiz;
  bit.Header.bfOffBits=sizeof(TBitmapHeader)+4*256;
  bit.Header.biSize=sizeof(BMPihead);
  bit.Header.biWidth=xSiz;
  bit.Header.biHeight=ySiz;
  bit.Header.biPlanes=1;
  bit.Header.biBitCount=8;
  bit.Header.biSizeImage=lx*ySiz;
  bit.Header.biClrUsed=256;
  bit.Header.biClrImportant=0;
  for(i=0;i<=255;i++)
    {
      cr=rr2(Colors[i]);
      cg=gg2(Colors[i]);
      cb=bb2(Colors[i]);
      bit.Header.color[i]= cr << 16 | cg << 8 | cb;
    } 
  k=0;
  for(j=0;j<=ySiz;j++)
    {
      for(i=0;i<=xSiz;i++)
        bit.bits[bit.Header.bfOffBits+k+i]=getPoint(bits,i,(ySiz-1)-j);
      k+=lx;  
    } 
      
  fwrite(bit.bits, 1, bit.Header.bfSize,ki);
  fclose(ki);    
}

void BmpEdMain::q_new()
{
  QString s;
  init_data();
  pbit->reDraw();  
  s.sprintf("BitEd - [%s]",bitname);
  setCaption(s);
}

void BmpEdMain::q_clear()
{
  QString s;
  
  int i;

  for(i=0; i<=xMaxX*xMaxY; i++)
    bits[i]=15;
  for(i=0;i<16;i++)  
    Colors[i]=defColors[i];
  for(i=16;i<256;i++)
    Colors[i]=0x00ffffff;

//  xSiz=32; ySiz=32;
  UndoLevel=0;
  
  pbit->reDraw();  
}

void BmpEdMain::q_bitstat8()
{
   bitmap->setItemChecked( bpp4, FALSE );
   bitmap->setItemChecked( bpp8, TRUE );
   bppstate=1;
}

void BmpEdMain::q_bitstat4()
{
   bitmap->setItemChecked( bpp4, TRUE );
   bitmap->setItemChecked( bpp8, FALSE );
   bppstate=0;
}

void BmpEdMain::q_rename()
{
  QString s;
  char cs[257];
  if(strlen(bitname)==0)  
    s.sprintf("%s","bm");
  else
    s.sprintf("%s",bitname);
  InputBox d(this, "Rename bitmap-array");
  d.aLine->setText(s);
  d.aLine->selectAll();
  if(d.exec())
    {
      s=d.aLine->text();
      strcpy(bitname,s);
      sprintf(cs,"BitEd - [%s]",bitname);
      setCaption(cs);
    }
  else if(strlen(bitname)==0)
    strcpy(bitname,"bmNoName");
}

void BmpEdMain::q_undo()
{
/*  int i,j;
  if(UndoLevel>0)
    {
       for(j=0;j<128;j++) bits[j]=Ubits[UndoLevel,j];
       for(j=0;j<128;j++) mask[j]=Umask[UndoLevel,j];
       pbit->spot.x=Uspot[UndoLevel].x;
       pbit->spot.y=Uspot[UndoLevel].y;
       UndoLevel=UndoLevel-1; 
       if(UndoLevel<0)
         UndoLevel=0;
       pbit->reDraw();  
    }*/
}

void BmpEdMain::done()
{
/*  int i,j;
  UndoLevel=UndoLevel+1;
  if(UndoLevel>5)
     {
        UndoLevel=5;
        for(i=4;i>=1;i--)
          {
             for(j=0;j<128;j++) Ubits[i,j]=Ubits[i+1,j];
             for(j=0;j<128;j++) Umask[i,j]=Umask[i+1,j];
             Uspot[i]=Uspot[i+1];
          }
     }   
   
  for(j=0;j<128;j++) Ubits[UndoLevel,j]=bits[j];
  for(j=0;j<128;j++) Umask[UndoLevel,j]=mask[j];

  Uspot[UndoLevel].x=pbit->spot.x;
  Uspot[UndoLevel].y=pbit->spot.y; */
}

void BmpEdMain::q_redo()
{
}

void BmpEdMain::q_resize()
{
  int val,i,j,k,l,x,y,xx,yy;
  char b,fl;
  QString s,r;
  s.sprintf("%i",xSiz);
  r.sprintf("%i",ySiz);
  
  setMinimumSize( width(), height() );
  
  XYInput d(this,"New Bitmap size");
  d.xLine->setText(s);
  d.yLine->setText(r);
  if(d.exec() == QDialog::Accepted)
    {
      s=d.xLine->text();
      r=d.yLine->text();
      xx=s.toInt();
      yy=r.toInt();
      b=0;
      for(i=0;i<s.length();i++)
        if( ! (s.mid(i,1)>="0" && s.mid(i,1)<="9"))
          b=b | 1;
      for(i=0;i<r.length();i++)
        if( ! (r.mid(i,1)>="0" && r.mid(i,1)<="9"))
          b=b | 1;
          
      if(!b)
         {
           xSiz=xx;
           ySiz=yy;
           pbit->reSizeBox(xx,yy);
           
           setMinimumSize( WinX, WinY );
           testBox -> resize(xSiz+12,ySiz+12);
           testBox -> move( 0, height()-testBox->height()-20);
//           pbit ->move(100 /*width()-pbit->width()-5*/,menu->height()+5);
           q_test();
        }
      else  
        QMessageBox::message( "Warning", "It's not numeric data");
      if(xx>95 | yy>95)
        {
           QMessageBox::message( "Warning", "X or Y value is too big");
           xx=95; yy=95;
        }  
    }
}

void BmpEdMain::q_about()
{
  QMessageBox::message( "About", 
  "Bitmap Editor\nfor Device Independent Bitmap .BMP files\n\nv 0.1 (beta)\n(c) 1997  by Zsolt Borka");
}

void BmpEdMain::q_test()
{
  char c,d,e;
  int i,j,k,lx,p,cr,cg,cb;
  TBitmap bit;
  
  lx=(xSiz+3)/4*4;
  
  for(i=0;i<=65535;i++)
    bit.bits[i]=0;
  bit.Header.bfType=0x4d42;
  bit.Header.bfSize=sizeof(TBitmapHeader)+4*256+lx*ySiz;
  bit.Header.bfOffBits=sizeof(TBitmapHeader)+4*256;
  bit.Header.biSize=sizeof(BMPihead);
  bit.Header.biWidth=xSiz;
  bit.Header.biHeight=ySiz;
  bit.Header.biPlanes=1;
  bit.Header.biBitCount=8;
  bit.Header.biSizeImage=lx*ySiz;
  bit.Header.biClrUsed=256;
  bit.Header.biClrImportant=0;
  for(i=0;i<=255;i++)
    {
      cr=rr2(Colors[i]);
      cg=gg2(Colors[i]);
      cb=bb2(Colors[i]);
      bit.Header.color[i]= cr << 16 | cg << 8 | cb;
    } 
  k=0;
  for(j=0;j<=ySiz;j++)
    {
      for(i=0;i<=xSiz;i++)
        bit.bits[bit.Header.bfOffBits+k+i]=getPoint(bits,i,(ySiz-1)-j);
        k=k+lx;
    } 

  testBox -> resize(xSiz+12,ySiz+12);
  testBox -> move( 0, height()-testBox->height()-20);

  QPixmap pm;
  pm.loadFromData((uchar *) &bit.bits, bit.Header.bfSize);
  bitBlt(testBox,6,6,&pm);
}

void BmpEdMain::q_rotUp()
{
   char  data[xMaxX+1];
   int i,j,x,y;
   for(i=0;i<=xSiz;i++)
     data[i]=getPoint(bits,i,0);
   for(y=0;y<ySiz-1;y++)
     for(x=0;x<xSiz;x++)
       plotPoint(bits,x,y,getPoint(bits,x,y+1));
   for(i=0;i<=xSiz;i++)
     plotPoint(bits,i,ySiz-1,data[i]);
   pbit->reDraw();  
}
void BmpEdMain::q_rotDown()
{
   char  data[xMaxX+1];
   int i,j,x,y;
   for(i=0;i<=xSiz;i++)
     data[i]=getPoint(bits,i,ySiz-1);
   for(y=ySiz-2;y>=0;y--)
     for(x=0;x<xSiz;x++)
       plotPoint(bits,x,y+1,getPoint(bits,x,y));
   for(i=0;i<=xSiz;i++)
     plotPoint(bits,i,0,data[i]);
   pbit->reDraw();  
}
void BmpEdMain::q_rotLeft()
{
   char  data[xMaxY+1];
   int x,y;
   for(y=0;y<=ySiz;y++)
     data[y]=getPoint(bits,0,y);
   for(y=0;y<ySiz;y++)
     for(x=0;x<xSiz-1;x++)
       plotPoint(bits,x,y,getPoint(bits,x+1,y));
   for(y=0;y<=xSiz;y++)
     plotPoint(bits,xSiz-1,y,data[y]);
   pbit->reDraw();  
}
void BmpEdMain::q_rotRight()
{
   char  data[xMaxX+1];
   int i,j,x,y;
   for(i=0;i<=ySiz;i++)
     data[i]=getPoint(bits,ySiz-1,i);
   for(y=0;y<ySiz;y++)
     for(x=xSiz-2;x>=0;x--)
       plotPoint(bits,x+1,y,getPoint(bits,x,y));
   for(i=0;i<=ySiz;i++)
     plotPoint(bits,0,i,data[i]);
   pbit->reDraw();  
}

void BmpEdMain::getLcolor(int v)
{
   pbit->lcolor=v;
   lBox -> setBackgroundColor(Colors[v]);   
}

void BmpEdMain::getRcolor(int v)
{
   pbit->rcolor=v;
   rBox -> setBackgroundColor(Colors[v]);   
}

void BmpEdMain::getRGBval()
{
//   Colors[i]=v;
   pbit->reDraw();
   lBox -> setBackgroundColor(Colors[pbit->lcolor]);   
   rBox -> setBackgroundColor(Colors[pbit->rcolor]);   
}

void BmpEdMain::cursorMoved(int x, int y)
{
   QString s;
   s.sprintf("x:%.2i - y:%.2i",x,y);
   label->setText(s);
}

void BmpEdMain::Functions(int v)
{
   int i;
   LToolNum=v;
   for(i=0; i<=4; i++)
     {
       if(i==v)
         idb[i]->setState(1);
       else  
         idb[i]->setState(0);
     }    
    pbit->setFunc((TDrwStyle) v);
}


// ******* zenetek ****************

void BmpEdMain::resizeEvent( QResizeEvent *e )
{
   NWidget::resizeEvent( e );

   int i,j;
   
   pbit ->move(120,menu->height()+Tool->height()+5);
//   pbit ->move(120 ,menu->height()+26+5);

   label->setGeometry( 0, rect().bottom()-19, 90, 20 );
   cpick->setGeometry(90, rect().bottom()-19, width()-90, 20 );
   
   testBox -> move( 0, height()-testBox->height()-20);
}

// ******* Fprogram ***************

#include "bitedit.moc"

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    BmpEdMain m;
    
    if(argc>1)
      {
         m.isPreload=TRUE;
         m.loadbits(argv[1]);
      }
    
    QPixmap pmap;
    pmap.loadFromData((unsigned char *) &rock50,bitmapSize(rock50));
    m.setBackgroundPixmap(pmap);

    a.setMainWidget( &m );
    m.show();
    return a.exec();
}
